
/******************************************************************************
* MODULE     : function_test.cc
* DESCRIPTION: Test functions
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "integer.hpp"
#include "function.hpp"
using namespace mml;

integer
factorial (integer i) {
  if (i == 0) return 1;
  return i * factorial (i-1);
}

int
main () {
  function<integer,integer> f (factorial, "factorial");
  function<integer,integer> g= 123;
  cout << "f\t= " << f << "\n";
  cout << "g\t= " << g << "\n";
  cout << "f(25)\t= " << f(25) << "\n";
  cout << "g(25)\t= " << g(25) << "\n\n";
 
  cout << "f\t= " << f << "\n\t\t\t\t" << f(25) << "\n";
  cout << "g\t= " << g << "\n\t\t\t\t" << g(25) << "\n";
  cout << "-f\t= " << -f << "\n\t\t\t\t" << (-f)(25) << "\n";
  cout << "f+g\t= " << f+g << "\n\t\t\t\t" << (f+g)(25) << "\n";
  cout << "f-g\t= " << f-g << "\n\t\t\t\t" << (f-g)(25) << "\n";
  cout << "f*g\t= " << f*g << "\n\t\t\t\t" << (f*g)(25) << "\n";
  cout << "f/g\t= " << f/g << "\n\t\t\t\t" << (f/g)(25) << "\n";
  cout << "2*g\t= " << 2*g << "\n\t\t\t\t" << (2*g)(25) << "\n";
  cout << "g*2\t= " << g*2 << "\n\t\t\t\t" << (g*2)(25) << "\n";
  cout << "g/2\t= " << g/2 << "\n\t\t\t\t" << (g/2)(25) << "\n";
  cout << "g%2\t= " << g%2 << "\n\t\t\t\t" << (g%2)(25) << "\n";
  return 0;
}
